Index: trunk/NEMO/TOP_SRC/LOBSTER/trclsm_lobster.F90
===================================================================
--- trunk/NEMO/TOP_SRC/LOBSTER/trclsm_lobster.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/LOBSTER/trclsm_lobster.F90	(revision 1119)
@@ -40,17 +40,45 @@
       !!----------------------------------------------------------------------
       CHARACTER (len=32) :: clname
+      INTEGER            :: jn
       !!
-      NAMELIST/natbio/ apmin, azmin, anmin, admin,                       &
-         &   redf, reddom, slopet, toptp, psinut, akno3, aknh4, rcchl,   &
-         &   rgamma, toptgz, tmaxgz, rgz,                                &
-         &   rppz, taus, aks, filmax, rpnaz, rdnaz, eggzoo, tauzn,       &
-         &   tmmaxp, tmminp, tmmaxz, tmminz, anumin, afdmin, taudn,      &
-         &   vsed, tmumax, aki, tmaxr, tminr, taunn, taudomn, xhr,       &
-         &   sedlam, sedlostpoc,                                         &
-         &   fphylab, fzoolab, fdetlab, fdbod
-      NAMELIST/natopt/ xkg0, xkr0, xkgp, xkrp, xlg, xlr, rpig
+#if defined key_trc_diaadd
+      ! definition of additional diagnostic as a structure
+      TYPE DIAG
+         CHARACTER(len = 20)  :: snamedia   !: short name
+         CHARACTER(len = 80 ) :: lnamedia   !: long name
+         CHARACTER(len = 20 ) :: unitdia    !: unit
+      END TYPE DIAG
+
+      TYPE(DIAG) , DIMENSION(jp_lobster_2d) :: lobdia2d
+      TYPE(DIAG) , DIMENSION(jp_lobster_3d) :: lobdia3d
+#endif
 #if defined key_trc_diabio
-      INTEGER :: ji
-      NAMELIST/natdbi/ctrbio,ctrbil,ctrbiu,nwritebio
+      ! definition of additional diagnostic as a structure
+      TYPE DIABIO
+         CHARACTER(len = 20)  :: snamebio   !: short name
+         CHARACTER(len = 80 ) :: lnamebio   !: long name
+         CHARACTER(len = 20 ) :: unitbio    !: unit
+      END TYPE DIABIO
+
+      TYPE(DIABIO) , DIMENSION(jp_lobster_trd) :: lobdiabio
+#endif
+
+      NAMELIST/namlobphy/ apmin, tmumax, rgamma, fphylab, tmmaxp, tmminp, &
+         &                rcchl, aki, toptp 
+      NAMELIST/namlobnut/ anmin, akno3, aknh4, taunn, psinut
+      NAMELIST/namlobzoo/ azmin, eggzoo, rgz, rppz, taus, aks, rpnaz,     &
+         &                rdnaz, tauzn, fzoolab, fdbod, tmmaxz, tmminz
+      NAMELIST/namlobdet/ admin, taudn, fdetlab, vsed
+      NAMELIST/namlobdom/ taudomn
+      NAMELIST/namlobsed/ sedlam, sedlostpoc
+      NAMELIST/namlobrat/ redf, reddom, slopet, tmaxr, tminr, xhr,        &
+         &                filmax, toptgz, tmaxgz, anumin, afdmin
+
+      NAMELIST/namlobopt/ xkg0, xkr0, xkgp, xkrp, xlg, xlr, rpig
+#if defined key_trc_diaadd
+      NAMELIST/namlobdia/nwritedia, lobdia3d, lobdia2d     ! additional diagnostics
+#endif
+#if defined key_trc_diabio
+      NAMELIST/namlobdbi/nwritebio, lobdiabio
 #endif
       !!----------------------------------------------------------------------
@@ -63,109 +91,168 @@
       !                               ! ----------------------
       clname ='namelist_lobster'
-      CALL ctlopn( numnat, clname, 'OLD', 'FORMATTED', 'SEQUENTIAL',   &
-         &           1, numout, .FALSE., 1 )
-
-      !                               ! natbio : biological parameters
-      !                               ! ------------------------------
-      apmin = 0.                           ! default values
-      azmin = 0.
-      anmin = 0.
-      admin = 0.
-      redf  = 0.
-      reddom = 0.
-      slopet = 0.
-      toptp = 0.
+      CALL ctlopn( numnat, clname, 'OLD', 'FORMATTED', 'SEQUENTIAL', 1, numout, .FALSE., 1 )
+
+      ! namlobphy : parameters for phytoplankton
+      apmin   = 0. 
+      tmumax  = 0. 
+      rgamma  = 0. 
+      fphylab = 0.  
+      tmmaxp  = 0.
+      tmminp  = 0.
+      rcchl   = 0. 
+      aki     = 0. 
+      toptp   = 0. 
+
+      REWIND( numnat )
+      READ  ( numnat, namlobphy )
+
+      IF(lwp) THEN
+          WRITE(numout,*) ' Namelist namlobphy'
+          WRITE(numout,*) '    minimum phytoplancton concentration                  apmin     =', apmin
+          WRITE(numout,*) '    phyto max growth rate                                tmumax    =', 86400 * tmumax, ' d'
+          WRITE(numout,*) '    phytoplankton exudation fraction                     rgamma    =', rgamma
+          WRITE(numout,*) '    NH4 fraction of phytoplankton exsudation             fphylab   =', fphylab
+          WRITE(numout,*) '    maximal phyto mortality rate                         tmmaxp    =', 86400 * tmmaxp
+          WRITE(numout,*) '    minimal phyto mortality rate                         tmminp    =', 86400 * tmminp
+          WRITE(numout,*) '    carbone/chlorophyl ratio                             rcchl     =', rcchl
+          WRITE(numout,*) '    light hlaf saturation constant                       aki       =', aki
+          WRITE(numout,*) '    optimal photosynthesis temperature                   toptp     =', toptp
+          WRITE(numout,*) ' '
+      ENDIF
+
+      ! namlobnut : parameters for nutrients
+      anmin  = 0.
       psinut = 0.
       akno3  = 0.
-      aknh4 = 0.
-      rcchl = 0.
-      rgamma= 0.
-      toptgz= 0.
-      tmaxgz= 0.
-      rgz   = 0.
-      rppz  = 0.
-      taus  = 0.
-      aks   = 0.
-      filmax= 0.
-      rpnaz = 0.
-      rdnaz = 0.
-      eggzoo= 0.
-      tauzn = 0.
-      tmmaxp= 0.
-      tmminp= 0.
-      tmmaxz= 0.
-      tmminz= 0.
-      anumin= 0.
-      afdmin= 0.
-      taudn = 0.
-      vsed  = 0.
-      tmumax= 0.
-      aki   = 0.
-      tmaxr   = 1./(     4.*rday)*0.
-      tminr   = 1./(24.*30.*rday)*0.
-      xhr=0.
-      sedlam=0.
-      sedlostpoc=0.
-      taudomn = 0.
-      taunn = 0.
-      fphylab = 0.
-      fzoolab = 0.
-      fdetlab = 0.
-      fdbod = 0.
-
-      REWIND( numnat )                     ! read natbio
-      READ  ( numnat, natbio )
-
-      IF(lwp) THEN
-          WRITE(numout,*) ' Namelist natbio'
-          WRITE(numout,*) '    minimum phytoplancton concentration                  apmin     =', apmin
-          WRITE(numout,*) '    minimum zooplancton   concentration                  azmin     =', azmin
+      aknh4  = 0.
+      taunn  = 0.
+
+      REWIND( numnat )
+      READ  ( numnat, namlobnut )
+      IF(lwp) THEN
+          WRITE(numout,*) ' Namelist namlobnut'
           WRITE(numout,*) '    minimum nutrients     concentration                  anmin     =', anmin
-          WRITE(numout,*) '    minimum detritus      concentration                  admin     =', admin
-          WRITE(numout,*) '    redfield ratio  c:n                                  redf      =', redf
-          WRITE(numout,*) '    van t hoff coefficient                               slopet    =', slopet
-          WRITE(numout,*) '    optimal photosynthesis temperature                   toptp     =', toptp
-          WRITE(numout,*) '    inhibition of no3 uptake by nh4                      psinut    =', psinut
           WRITE(numout,*) '    half-saturation nutrient for no3 uptake              akno3     =', akno3
           WRITE(numout,*) '    half-saturation nutrient for nh4 uptake              aknh4     =', aknh4
-          WRITE(numout,*) '    carbone/chlorophyl ratio                             rcchl     =', rcchl
-          WRITE(numout,*) '    phytoplankton exudation fraction                     rgamma    =', rgamma
-          WRITE(numout,*) '    optimal temperature for zoo growth                   toptgz    =', toptgz
-          WRITE(numout,*) '    maximal temperature for zoo growth                   tmaxgz    =', tmaxgz
+          WRITE(numout,*) '    nitrification rate                                   taunn     =', taunn
+          WRITE(numout,*) '    inhibition of no3 uptake by nh4                      psinut    =', psinut
+          WRITE(numout,*) ' '
+      ENDIF
+
+      ! namlobzoo : parameters for zooplankton
+      azmin   = 0.
+      rgz     = 0.
+      rppz    = 0.
+      taus    = 0.
+      aks     = 0.
+      rpnaz   = 0.
+      rdnaz   = 0.
+      eggzoo  = 0.
+      tauzn   = 0.
+      tmmaxz  = 0.
+      tmminz  = 0.
+      fzoolab = 0.
+      fdbod   = 0.
+
+      REWIND( numnat )
+      READ  ( numnat, namlobzoo )
+
+      IF(lwp) THEN
+          WRITE(numout,*) ' Namelist namlobzoo'
+          WRITE(numout,*) '    minimum zooplancton   concentration                  azmin     =', azmin
+          WRITE(numout,*) '    minimum  for zoo concentration                       eggzoo    =', eggzoo
           WRITE(numout,*) '    widtht of zoo temperature FUNCTION                   rgz       =', rgz
           WRITE(numout,*) '    zoo preference for phyto                             rppz      =', rppz
           WRITE(numout,*) '    maximal zoo grazing rate                             taus      =', 86400 * taus, ' d'
           WRITE(numout,*) '    half saturation constant for zoo food                aks       =', aks
-          WRITE(numout,*) '    maximal mass clearance rate for zoo                  filmax    =', filmax
           WRITE(numout,*) '    non-assimilated phyto by zoo                         rpnaz     =', rpnaz
           WRITE(numout,*) '    non-assimilated detritus by zoo                      rdnaz     =', rdnaz
-          WRITE(numout,*) '    minimum  for zoo concentration                       eggzoo    =', eggzoo
           WRITE(numout,*) '    zoo specific excretion rate                          tauzn     =', 86400 * tauzn
-          WRITE(numout,*) '    maximal phyto mortality rate                         tmmaxp    =', 86400 * tmmaxp
-          WRITE(numout,*) '    minimal phyto mortality rate                         tmminp    =', 86400 * tmminp
           WRITE(numout,*) '    maximal zoo mortality rate                           tmmaxz    =', 86400 * tmmaxz
           WRITE(numout,*) '    minimal zoo mortality rate                           tmminz    =', 86400 * tmminz
+          WRITE(numout,*) '    NH4 fraction of zooplankton excretion                fzoolab   =', fzoolab
+          WRITE(numout,*) '    Zooplankton mortality fraction that goes to detritus fdbod     =', fdbod
+          WRITE(numout,*) ' '
+      ENDIF
+
+      ! namlobdet : parameters for detritus
+      admin   = 0.
+      taudn   = 0.
+      vsed    = 0.
+      fdetlab = 0.
+
+      REWIND( numnat )
+      READ  ( numnat, namlobdet )
+
+      IF(lwp) THEN
+          WRITE(numout,*) ' Namelist namlobdet'
+          WRITE(numout,*) '    minimum detritus      concentration                  admin     =', admin
+          WRITE(numout,*) '    detrital breakdown rate                              taudn     =', 86400 * taudn , ' d'
+          WRITE(numout,*) '    detritus sedimentation speed                         vsed      =', 86400 * vsed  , ' d'
+          WRITE(numout,*) '    NH4 fraction of detritus dissolution                 fdetlab   =', fdetlab
+          WRITE(numout,*) ' '
+      ENDIF
+
+      ! namlobdom : parameters for DOM
+      taudomn = 0.
+
+      REWIND( numnat ) 
+      READ  ( numnat, namlobdom )
+
+      IF(lwp) THEN
+          WRITE(numout,*) ' Namelist namlobdom'
+          WRITE(numout,*) '    dom remineralisation rate                            taudomn   =', taudomn
+          WRITE(numout,*) ' '
+      ENDIF
+
+      ! namlobsed : parameters from aphotic layers to sediment
+      sedlam     = 0.
+      sedlostpoc = 0.
+
+      REWIND( numnat )
+      READ  ( numnat, namlobsed )
+
+      IF(lwp) THEN
+          WRITE(numout,*) ' Namelist namlobsed'
+          WRITE(numout,*) '    time coeff of POC in sediments                       sedlam    =', sedlam
+          WRITE(numout,*) '    Sediment geol loss for POC                           sedlostpoc=', sedlostpoc
+          WRITE(numout,*) ' '
+      ENDIF
+
+      ! namlobrat : general coefficient
+      redf   = 0.
+      reddom = 0.
+      slopet = 0.
+      tmaxr  = 1./(     4.*rday)*0.
+      tminr  = 1./(24.*30.*rday)*0.
+      xhr    = 0.
+      filmax = 0.
+      toptgz = 0.
+      tmaxgz = 0.
+      anumin = 0.
+      afdmin = 0.
+
+      REWIND( numnat )
+      READ  ( numnat, namlobrat )
+
+      IF(lwp) THEN
+          WRITE(numout,*) ' Namelist namlobrat'
+          WRITE(numout,*) '    redfield ratio  c:n for phyto                        redf      =', redf 
+          WRITE(numout,*) '    redfield ratio  c:n for DOM                          reddom    =', reddom 
+          WRITE(numout,*) '    van t hoff coefficient                               slopet    =', slopet
+          WRITE(numout,*) '    maximum damping for d z or p                         tmaxr     =', tmaxr
+          WRITE(numout,*) '    damping-remineralisation rate                        tminr     =', tminr
+          WRITE(numout,*) '    coeff for martin''s remineralistion                  xhr       =', xhr
+          WRITE(numout,*) '    maximal mass clearance rate for zoo                  filmax    =', filmax
+          WRITE(numout,*) '    optimal temperature for zoo growth                   toptgz    =', toptgz
+          WRITE(numout,*) '    maximal temperature for zoo growth                   tmaxgz    =', tmaxgz
           WRITE(numout,*) '    nutrient threshold for phyto mort                    anumin    =', anumin
           WRITE(numout,*) '    food threshold for zoo mort                          afdmin    =', afdmin
-          WRITE(numout,*) '    detrital breakdown rate                              taudn     =', 86400 * taudn , ' d'
-          WRITE(numout,*) '    detritus sedimentation speed                         vsed      =', 86400 * vsed  , ' d'
-          WRITE(numout,*) '    phyto max growth rate                                tmumax    =', 86400 * tmumax, ' d'
-          WRITE(numout,*) '    light hlaf saturation constant                       aki       =', aki
-          WRITE(numout,*) '    maximum damping for d z or p                         tmaxr     =', tmaxr
-          WRITE(numout,*) '    damping-remineralisation rate                        tminr     =', tminr
-          WRITE(numout,*) '    nitrification rate                                   taunn     =', taunn
-          WRITE(numout,*) '    dom remineralisation rate                            taudomn   =', taudomn
-          WRITE(numout,*) '    coeff for martin''s remineralistion                  xhr       =', xhr
-          WRITE(numout,*) '    time coeff of POC in sediments                       sedlam    =', sedlam
-          WRITE(numout,*) '    Sediment geol loss for POC                           sedlostpoc=', sedlostpoc
-          WRITE(numout,*) '    NH4 fraction of phytoplankton exsudation             fphylab   =', fphylab
-          WRITE(numout,*) '    NH4 fraction of zooplankton excretion                fzoolab   =', fzoolab
-          WRITE(numout,*) '    NH4 fraction of detritus dissolution                 fdetlab   =', fdetlab
-          WRITE(numout,*) '    Zooplankton mortality fraction that goes to detritus fdbod     =', fdbod
-      ENDIF
-
-      !                               ! natopt : optical parameters
-      !                               ! ---------------------------
-      xkg0  = 0.                           ! default values
+          WRITE(numout,*) ' '
+      ENDIF
+
+
+      ! namlobopt : optical parameters
+      xkg0  = 0. 
       xkr0  = 0.
       xkgp  = 0.
@@ -175,10 +262,10 @@
       rpig  = 0.
 
-      REWIND( numnat )                     ! read natopt
-      READ  ( numnat, natopt )       
-
-      IF(lwp) THEN                         ! control print
+      REWIND( numnat )
+      READ  ( numnat, namlobopt )
+
+      IF(lwp) THEN                         
          WRITE(numout,*)
-         WRITE(numout,*) ' Namelist natopt'
+         WRITE(numout,*) ' Namelist namlobopt'
          WRITE(numout,*) '    green   water absorption coeff                       xkg0  = ', xkg0
          WRITE(numout,*) '    red water absorption coeff                           xkr0  = ', xkr0
@@ -188,29 +275,95 @@
          WRITE(numout,*) '    red   chl exposant                                   xlr   = ', xlr
          WRITE(numout,*) '    chla/chla+phea ratio                                 rpig  = ', rpig
-      ENDIF
+         WRITE(numout,*) ' '
+      ENDIF
+
+#if defined key_trc_diaadd
+
+      ! Namelist namlobdia
+      ! -------------------
+      nwritedia = 10                   ! default values
+
+      DO jn = jp_lob0_2d, jp_lob1_2d
+         WRITE(ctrc2d(jn),'("2D_",I1)') jn                      ! short name
+         WRITE(ctrc2l(jn),'("2D DIAGNOSTIC NUMBER ",I2)') jn    ! long name
+         ctrc2u(jn) = ' '                                       ! units
+      END DO
+      !                                 ! 3D output arrays
+      DO jn = jp_lob0_3d, jp_lob1_3d
+         WRITE(ctrc3d(jn),'("3D_",I1)') jn                      ! short name
+         WRITE(ctrc3l(jn),'("3D DIAGNOSTIC NUMBER ",I2)') jn    ! long name
+         ctrc3u(jn) = ' '                                       ! units
+      END DO
+
+      REWIND( numnat )               ! read natrtd
+      READ  ( numnat, namlobdia )
+
+      DO jn = jp_lob0_2d, jp_lob1_2d
+         ctrc2d(jn) = lobdia2d(jn)%snamedia
+         ctrc2l(jn) = lobdia2d(jn)%lnamedia
+         ctrc2u(jn) = lobdia2d(jn)%unitdia
+      END DO
+
+      DO jn = jp_lob0_3d, jp_lob1_3d
+         ctrc3d(jn) = lobdia3d(jn)%snamedia
+         ctrc3l(jn) = lobdia3d(jn)%lnamedia
+         ctrc3u(jn) = lobdia3d(jn)%unitdia
+      END DO
+
+      IF(lwp) THEN                   ! control print
+         WRITE(numout,*)
+         WRITE(numout,*) ' Namelist : natadd'
+         WRITE(numout,*) '    frequency of outputs for additional arrays nwritedia = ', nwritedia
+         DO jn = jp_lob0_3d, jp_lob1_3d
+            WRITE(numout,*) '   3d output field No : ',jn
+            WRITE(numout,*) '   short name         : ', TRIM(ctrc3d(jn))
+            WRITE(numout,*) '   long name          : ', TRIM(ctrc3l(jn))
+            WRITE(numout,*) '   unit               : ', TRIM(ctrc3u(jn))
+            WRITE(numout,*) ' '
+         END DO
+
+         DO jn = jp_lob0_2d, jp_lob1_2d
+            WRITE(numout,*) '   2d output field No : ',jn
+            WRITE(numout,*) '   short name         : ', TRIM(ctrc2d(jn))
+            WRITE(numout,*) '   long name          : ', TRIM(ctrc2l(jn))
+            WRITE(numout,*) '   unit               : ', TRIM(ctrc2u(jn))
+            WRITE(numout,*) ' '
+         END DO
+      ENDIF
+#endif
 
 #if defined key_trc_diabio
 
-      !                               ! natdbi : bio diagnostics
-      !                               ! ------------------------
+      ! namlobdbi : bio diagnostics
       nwritebio = 10                     ! default values
-      DO ji = 1, jpdiabio
-         IF(     ji <  10 ) THEN   ;   WRITE (ctrbio(ji),'("BIO_",I1)') ji      ! short name
-         ELSEIF (ji < 100 ) THEN   ;   WRITE (ctrbio(ji),'("BIO_",I2)') ji   
-         ELSE                      ;   WRITE (ctrbio(ji),'("BIO_",I3)') ji
+
+      DO jn = jp_lob0_trd, jp_lob1_trd
+         IF(     jn <  10 ) THEN   ;   WRITE (ctrbio(jn),'("BIO_",I1)') jn      ! short name
+         ELSEIF (jn < 100 ) THEN   ;   WRITE (ctrbio(jn),'("BIO_",I2)') jn   
+         ELSE                      ;   WRITE (ctrbio(jn),'("BIO_",I3)') jn
          ENDIF
-         WRITE(ctrbil(ji),'("BIOLOGICAL TREND NUMBER ",I2)') ji                 ! long name
-         ctrbiu(ji) = 'mmoleN/m3/s '                                            ! units
-      END DO
-
-      REWIND( numnat )                     ! read natdbi
-      READ  ( numnat, natdbi )  
-
-      IF(lwp) THEN
+         WRITE(ctrbil(jn),'("BIOLOGICAL TREND NUMBER ",I2)') jn                 ! long name
+         ctrbiu(jn) = 'mmoleN/m3/s '                                            ! units
+      END DO
+
+      REWIND( numnat )
+      READ  ( numnat, namlobdbi ) 
+ 
+      DO jn = jp_lob0_trd, jp_lob1_trd
+         ctrbio(jn) = lobdiabio(jn)%snamebio
+         ctrbil(jn) = lobdiabio(jn)%lnamebio
+         ctrbiu(jn) = lobdiabio(jn)%unitbio
+      END DO
+
+      IF(lwp) THEN                   ! control print
          WRITE(numout,*)
-         WRITE(numout,*) ' Namelist natdbi'
-         WRITE(numout,*) '    frequency of outputs for biological outputs  nwritebio = ', nwritebio
-         DO ji = 1, jpdiabio
-            WRITE(numout,*) '     name of biological trend No :',ji,' : ',ctrbio(ji), ctrbil(ji), ' in ', ctrbiu(ji)
+         WRITE(numout,*) ' Namelist : namlobdbi'
+         WRITE(numout,*) '    frequency of outputs for biological trends nwritebio = ', nwritebio
+         DO jn = jp_lob0_trd, jp_lob1_trd
+            WRITE(numout,*) '   biological trend No : ',jn
+            WRITE(numout,*) '   short name         : ', TRIM(ctrbio(jn))
+            WRITE(numout,*) '   long name          : ', TRIM(ctrbil(jn))
+            WRITE(numout,*) '   unit               : ', TRIM(ctrbiu(jn))
+            WRITE(numout,*) ' '
          END DO
       END IF
Index: trunk/NEMO/TOP_SRC/LOBSTER/trcopt.F90
===================================================================
--- trunk/NEMO/TOP_SRC/LOBSTER/trcopt.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/LOBSTER/trcopt.F90	(revision 1119)
@@ -17,5 +17,5 @@
    !!----------------------------------------------------------------------
    USE oce_trc         !
-   USE trp_trc
+   USE trc
    USE sms_lobster
    USE prtctl_trc      ! Print control for debbuging
@@ -136,5 +136,5 @@
          WRITE(charout, FMT="('opt')")
          CALL prt_ctl_trc_info(charout)
-         CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm )
+         CALL prt_ctl_trc( tab4d=trn, mask=tmask, clinfo=ctrcnm )
       ENDIF
 
Index: trunk/NEMO/TOP_SRC/LOBSTER/trcsed.F90
===================================================================
--- trunk/NEMO/TOP_SRC/LOBSTER/trcsed.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/LOBSTER/trcsed.F90	(revision 1119)
@@ -15,5 +15,5 @@
    !!----------------------------------------------------------------------
    USE oce_trc         !
-   USE trp_trc
+   USE trc
    USE sms_lobster
    USE lbclnk
Index: trunk/NEMO/TOP_SRC/PISCES/p4zbio.F90
===================================================================
--- trunk/NEMO/TOP_SRC/PISCES/p4zbio.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/PISCES/p4zbio.F90	(revision 1119)
@@ -15,5 +15,5 @@
    !!----------------------------------------------------------------------
    USE oce_trc         !
-   USE trp_trc         ! 
+   USE trc         ! 
    USE sms_pisces      ! 
    USE p4zsink         ! 
@@ -131,6 +131,5 @@
 
 # if defined key_trc_dia3d && defined key_kriest
-!!gm potential bug  hard coded index on trc3d
-      trc3d(:,:,:,11) = tra(:,:,:,jpcal) * xnegtr(:,:,:) * 1.e3 * rfact2r
+      trc3d(:,:,:,jp_pcs0_3d + 10) = tra(:,:,:,jpcal) * xnegtr(:,:,:) * 1.e3 * rfact2r
 # endif
       !
Index: trunk/NEMO/TOP_SRC/PISCES/p4zche.F90
===================================================================
--- trunk/NEMO/TOP_SRC/PISCES/p4zche.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/PISCES/p4zche.F90	(revision 1119)
@@ -18,5 +18,5 @@
    !!----------------------------------------------------------------------
    USE oce_trc         !
-   USE trp_trc         !
+   USE trc         !
    USE sms_pisces      ! 
 
Index: trunk/NEMO/TOP_SRC/PISCES/p4zflx.F90
===================================================================
--- trunk/NEMO/TOP_SRC/PISCES/p4zflx.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/PISCES/p4zflx.F90	(revision 1119)
@@ -19,5 +19,5 @@
    USE trc
    USE oce_trc         !
-   USE trp_trc
+   USE trc
    USE sms_pisces
    USE prtctl_trc
@@ -167,8 +167,8 @@
 # if defined key_trc_diaadd
             ! Save diagnostics
-            trc2d(ji,jj,1) = ( zfld - zflu ) * 1000.
-            trc2d(ji,jj,2) = ( zfld16 - zflu16 ) * 1000.
-            trc2d(ji,jj,3) = zkgco2(ji,jj)
-            trc2d(ji,jj,4) = atcco2 - zh2co3(ji,jj) / ( chemc(ji,jj,1) + rtrn )
+            trc2d(ji,jj,jp_pcs0_2d    ) = ( zfld - zflu ) * 1000.
+            trc2d(ji,jj,jp_pcs0_2d + 1) = ( zfld16 - zflu16 ) * 1000.
+            trc2d(ji,jj,jp_pcs0_2d + 2) = zkgco2(ji,jj)
+            trc2d(ji,jj,jp_pcs0_2d + 3) = atcco2 - zh2co3(ji,jj) / ( chemc(ji,jj,1) + rtrn )
 # endif
          END DO
@@ -209,18 +209,18 @@
       !! ** Purpose :   Initialization of atmospheric conditions
       !!
-      !! ** Method  :   Read the natext namelist and check the parameters
+      !! ** Method  :   Read the nampisext namelist and check the parameters
       !!      called at the first timestep (nittrc000)
-      !! ** input   :   Namelist natext
+      !! ** input   :   Namelist nampisext
       !!
       !!----------------------------------------------------------------------
 
-      NAMELIST/natext/ atcco2
+      NAMELIST/nampisext/ atcco2
 
       REWIND( numnat )                     ! read numnat
-      READ  ( numnat, natext )
+      READ  ( numnat, nampisext )
 
       IF(lwp) THEN                         ! control print
          WRITE(numout,*) ' '
-         WRITE(numout,*) ' Namelist parameters for air-sea exchange, natext'
+         WRITE(numout,*) ' Namelist parameters for air-sea exchange, nampisext'
          WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
          WRITE(numout,*) '    Atmospheric pCO2      atcco2      =', atcco2
Index: trunk/NEMO/TOP_SRC/PISCES/p4zint.F90
===================================================================
--- trunk/NEMO/TOP_SRC/PISCES/p4zint.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/PISCES/p4zint.F90	(revision 1119)
@@ -14,5 +14,5 @@
    !!----------------------------------------------------------------------
    USE oce_trc         !
-   USE trp_trc
+   USE trc
    USE sms_pisces
 
Index: trunk/NEMO/TOP_SRC/PISCES/p4zlim.F90
===================================================================
--- trunk/NEMO/TOP_SRC/PISCES/p4zlim.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/PISCES/p4zlim.F90	(revision 1119)
@@ -16,5 +16,5 @@
    USE trc
    USE oce_trc         !
-   USE trp_trc         ! 
+   USE trc         ! 
    USE sms_pisces      ! 
 
@@ -180,20 +180,20 @@
       !! ** Purpose :   Initialization of nutrient limitation parameters
       !!
-      !! ** Method  :   Read the natlim namelist and check the parameters
+      !! ** Method  :   Read the nampislim namelist and check the parameters
       !!      called at the first timestep (nittrc000)
       !!
-      !! ** input   :   Namelist natlim
+      !! ** input   :   Namelist nampislim
       !!
       !!----------------------------------------------------------------------
 
-      NAMELIST/natlim/ conc0, conc1, conc2, conc2m, conc3, conc3m,   &
+      NAMELIST/nampislim/ conc0, conc1, conc2, conc2m, conc3, conc3m,   &
          &             concnnh4, concdnh4, xksi1, xksi2, xkdoc, caco3r
 
       REWIND( numnat )                     ! read numnat
-      READ  ( numnat, natlim )
+      READ  ( numnat, nampislim )
 
       IF(lwp) THEN                         ! control print
          WRITE(numout,*) ' '
-         WRITE(numout,*) ' Namelist parameters for nutrient limitations, natlim'
+         WRITE(numout,*) ' Namelist parameters for nutrient limitations, nampislim'
          WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
          WRITE(numout,*) '    mean rainratio                            caco3r    =', caco3r
Index: trunk/NEMO/TOP_SRC/PISCES/p4zlys.F90
===================================================================
--- trunk/NEMO/TOP_SRC/PISCES/p4zlys.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/PISCES/p4zlys.F90	(revision 1119)
@@ -19,5 +19,5 @@
    USE trc
    USE oce_trc         !
-   USE trp_trc
+   USE trc
    USE sms_pisces
    USE prtctl_trc
@@ -151,7 +151,7 @@
 
 # if defined key_trc_dia3d
-         trc3d(:,:,:,1) = hi(:,:,:)
-         trc3d(:,:,:,2) = zco3(:,:,:)
-         trc3d(:,:,:,3) = aksp(:,:,:) / calcon
+         trc3d(:,:,:,jp_pcs0_3d    ) = hi(:,:,:)
+         trc3d(:,:,:,jp_pcs0_3d + 1) = zco3(:,:,:)
+         trc3d(:,:,:,jp_pcs0_3d + 2) = aksp(:,:,:) / calcon
 # endif
       !
@@ -171,19 +171,19 @@
       !! ** Purpose :   Initialization of CaCO3 dissolution parameters
       !!
-      !! ** Method  :   Read the natcal namelist and check the parameters
+      !! ** Method  :   Read the nampiscal namelist and check the parameters
       !!      called at the first timestep (nittrc000)
       !!
-      !! ** input   :   Namelist natcal
+      !! ** input   :   Namelist nampiscal
       !!
       !!----------------------------------------------------------------------
 
-      NAMELIST/natcal/ kdca, nca
+      NAMELIST/nampiscal/ kdca, nca
 
       REWIND( numnat )                     ! read numnat
-      READ  ( numnat, natcal )
+      READ  ( numnat, nampiscal )
 
       IF(lwp) THEN                         ! control print
          WRITE(numout,*) ' '
-         WRITE(numout,*) ' Namelist parameters for CaCO3 dissolution, natcal'
+         WRITE(numout,*) ' Namelist parameters for CaCO3 dissolution, nampiscal'
          WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
          WRITE(numout,*) '    diss. rate constant calcite (per month)   kdca      =', kdca
Index: trunk/NEMO/TOP_SRC/PISCES/p4zmeso.F90
===================================================================
--- trunk/NEMO/TOP_SRC/PISCES/p4zmeso.F90	(revision 1118)
+++ trunk/NEMO/TOP_SRC/PISCES/p4zmeso.F90	(revision 1119)
@@ -16,5 +16,5 @@
    USE trc
    USE oce_trc         !
-   USE trp_trc         ! 
+   USE trc         ! 
    USE sms_pisces      ! 
    USE prtctl_trc
@@ -299,21 +299,21 @@
       !! ** Purpose :   Initialization of mesozooplankton parameters
       !!
-      !! ** Method  :   Read the natmes namelist and check the parameters
+      !! ** Method  :   Read the nampismes namelist and check the parameters
       !!      called at the first timestep (nittrc000)
       !!
-      !! ** input   :   Namelist natmes
+      !! ** input   :   Namelist nampismes
       !!
       !!----------------------------------------------------------------------
 
-      NAMELIST/natmes/ grazrat2,resrat2,mzrat2,xprefc, xprefp, &
+      NAMELIST/nampismes/ grazrat2,resrat2,mzrat2,xprefc, xprefp, &
          &             xprefz, xprefpoc, xkgraz2, epsher2, sigma2, unass2, grazflux
 
       REWIND( numnat )                     ! read numnat
-      READ  ( numnat, natmes )
+      READ  ( numnat, nampismes )
 
 
       IF(lwp) THEN                         ! control print
          WRITE(numout,*) ' ' 
-         WRITE(numout,*) ' Namelist parameters for mesozooplankton, natmes'
+         WRITE(numout,*) ' Namelist parameters for mesozooplankton, nampismes'
          WRITE(numout,*) ' ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
          WRITE(numout,*) '    zoo preference for phyto                  xprefc    =', xprefc
